# Generated by Django 5.1.8 on 2025-04-10 08:24

import completion.models
import django.db.models.deletion
import django.utils.timezone
import model_utils.fields
import opaque_keys.edx.django.models
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    replaces = [
        ("completion", "0001_initial"),
        ("completion", "0002_auto_20180125_1510"),
        ("completion", "0003_learning_context"),
    ]

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="BlockCompletion",
            fields=[
                (
                    "created",
                    model_utils.fields.AutoCreatedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="created",
                    ),
                ),
                (
                    "modified",
                    model_utils.fields.AutoLastModifiedField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="modified",
                    ),
                ),
                ("id", models.BigAutoField(primary_key=True, serialize=False)),
                (
                    "context_key",
                    opaque_keys.edx.django.models.LearningContextKeyField(
                        db_column="course_key", max_length=255
                    ),
                ),
                (
                    "block_key",
                    opaque_keys.edx.django.models.UsageKeyField(max_length=255),
                ),
                ("block_type", models.CharField(max_length=64)),
                (
                    "completion",
                    models.FloatField(validators=[completion.models.validate_percent]),
                ),
                (
                    "user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "unique_together": {("context_key", "block_key", "user")},
                "index_together": {
                    ("context_key", "block_type", "user"),
                    ("user", "context_key", "modified"),
                },
                "get_latest_by": "modified",
            },
        ),
    ]
